CVE-2014-3626 Directory Traversal in Grails Resources Plugin


Severity

Important

Vendor

Grails by Pivotal

Versions Affected
  • Resources plugin versions 1.2.0 - 1.2.12
  • Earlier versions may also be affected but were not assessed
Description

The Grails Resource Plugin often has to exchange URIs for resources with other internal components. Those other components will decode any URI passed to them. To protect against directory traversal the Grails Resource Plugin did the following:

  • normalized the URI
  • checked the normalized URI did not step outside the appropriate root directory (e.g. the web application root)
  • decoded the URI and checked that this did not introduce additional /../ (and similar) sequences

A bug was introduced where the Grails Resource Plugin returned the decoded version of the URI rather than the normalized version of the URI after the directory traversal check. This exposed a double decoding vulnerability.

To address this issue, the Grails Resource Plugin now repeatedly decodes the URI up to three times or until decoding no longer changes the URI. If the decode limit of 3 is exceeded the URI is rejected. A side-effect of this is that the Grails Resource Plugin is unable to serve a resource that includes a ‘%’ character in the full path to the resource.

Not all environments are vulnerable because of the differences in URL resolving in different servlet containers. Applications deployed to Tomcat 8 and Jetty 9 were found not not be vulnerable, however applications deployed to JBoss EAP 6.3 / JBoss AS 7.4 and JBoss AS 7.1 were found to be vulnerable (other JBoss versions weren’t tested). In certain cases JBoss returns JBoss specific vfs protocol urls from URL resolution methods (ClassLoader.getResources). The JBoss vfs URL protocol supports resolving any file on the filesystem. This made the directory traversal possible. There may be other containers, in addition to JBoss, on which this vulnerability is exposed.

Mitigation

Users of affected versions should apply the following mitigation:

  • upgrade to resources plugin version 1.2.13
Credit

This issue was identified by Mr. Preecha Jeangsiriphan.

References
History

2017-05-25: Initial vulnerability report published.